
Public Class Form1
    Dim TotalLines As Integer = 0
    Dim bm As New Bitmap(6000, 6000)
    Dim bm1 As New Bitmap(1, 1)
    Dim NumFiles
    Dim FileIndex
    Dim FileArray(10) As String
    Dim Zoom = False
    Dim Pixels As Integer = 0
    Dim Lines As Integer = 0
    Dim ScrollPos = New Point(1, 1)

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        btnZoom.Enabled = False
        btnSave.Enabled = False
    End Sub

    Private Sub LookForDirectory_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LookForDirectory.Click
        LookForDirectory.Enabled = True
        btnZoom.Enabled = False
        btnSave.Enabled = False
        Dim bm As New Bitmap(5000, 5000)
        Dim bm1 As New Bitmap(1, 1)
        Zoom = False
        Pixels = 0
        Lines = 0
        TotalLines = 0
        Dim cntr
        If (FileBrowser.ShowDialog() = Windows.Forms.DialogResult.OK) Then
            NumFiles = FileBrowser.FileNames.Length
            FileArray(NumFiles - 1) = FileBrowser.FileNames(0).ToString
            For cntr = 0 To NumFiles - 2
                FileArray(cntr) = FileBrowser.FileNames(cntr + 1).ToString
            Next
            TargetFile.Text = FileArray(0).ToString
        End If
        '       LookForDirectory.Enabled = False
        btnZoom.Enabled = False
        btnSave.Enabled = False
        System.Windows.Forms.Application.DoEvents()
        Display()
    End Sub

    Public Sub Display()
        Dim x
        Dim y
        Dim z = 0
        Dim PriHdr(15) As Byte
        Dim PriHdrLen = 16
        Dim InData(1) As Byte
        Dim RecType = 0
        Dim RecLen As Integer = 0
        Dim TotalRecLen As Integer
        Dim BPP As Byte = 0
        Dim Compress
        Dim Pixel

        For FileIndex = 0 To NumFiles - 1
            Dim inStream As New IO.FileStream(FileArray(FileIndex).ToString, IO.FileMode.Open, IO.FileAccess.Read) 'Overwrite
            Dim inFile As New IO.BinaryReader(inStream)    'Open a binary file to read in 
            PriHdr = inFile.ReadBytes(PriHdrLen)
            TotalRecLen = (CInt(PriHdr(4)) << 24) + (CInt(PriHdr(5)) << 16) + (CInt(PriHdr(6)) << 8) + CInt(PriHdr(7))
            Dim Record(TotalRecLen - PriHdrLen - 1) As Byte
            Record = inFile.ReadBytes(TotalRecLen - PriHdrLen)
            For x = 0 To (TotalRecLen - PriHdrLen - 1)
                RecType = Record(x)
                RecLen = (CInt(Record(x + 1)) << 8) + CInt(Record(x + 2))
                If RecType = 1 Then
                    BPP = CInt(Record(x + 3))
                    Pixels = (CInt(Record(x + 4)) << 8) + CInt(Record(x + 5))
                    Lines = (CInt(Record(x + 6)) << 8) + CInt(Record(x + 7))
                    Compress = CInt(Record(x + 8))
                    x = x + RecLen - 1
                Else
                    x = x + RecLen - 1
                End If
            Next
            '       Dim bm1 As New Bitmap(bm, Pixels, TotalLines + Lines)
            '      bm = bm1.Clone
            For y = TotalLines To TotalLines + Lines - 1
                For x = 0 To Pixels - 1
                    Pixel = inFile.ReadByte
                    bm.SetPixel(x, y, Color.FromArgb(255, Pixel, Pixel, Pixel))
                Next
            Next
            TotalLines = TotalLines + Lines
            PictureBox1.Image = bm
            inFile.Close()
            inStream.Close()
            System.Windows.Forms.Application.DoEvents()
        Next
        Dim cloneRect As New Rectangle(0, 0, Pixels - 1, TotalLines - 1)
        Dim format As System.Drawing.Imaging.PixelFormat = bm.PixelFormat
        Dim bm1 As Bitmap = bm.Clone(cloneRect, format)     'crop original bm to right size
        PictureBox1.Image = bm1
        ImageSize.Text = "X:" & Pixels.ToString & " Y:" & TotalLines.ToString
        LookForDirectory.Enabled = True
        btnZoom.Enabled = True
        btnSave.Enabled = True
    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        bm1.Dispose()
        bm.Dispose()
        End
    End Sub

    Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click
        Dim cloneRect As New Rectangle(0, 0, Pixels - 1, TotalLines - 1)
        Dim format As System.Drawing.Imaging.PixelFormat = bm.PixelFormat
        Dim bm1 As Bitmap = bm.Clone(cloneRect, format)     'crop original bm to right size
        bm1.Save(FileArray(0).Substring(0, (FileArray(0).Length - 5)) & ".bmp")
    End Sub

    Private Sub btnZoom_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnZoom.Click
        If Zoom = False Then
            ScrollPos = New Point(0 - Panel1.AutoScrollPosition.X, 0 - Panel1.AutoScrollPosition.Y)
            Panel1.AutoScroll = False
            PictureBox1.Dock = DockStyle.Fill
            PictureBox1.SizeMode = PictureBoxSizeMode.Zoom
            Zoom = True
        Else
            Panel1.AutoScroll = True
            PictureBox1.Dock = DockStyle.None
            PictureBox1.SizeMode = PictureBoxSizeMode.AutoSize
            Panel1.AutoScrollPosition = ScrollPos
            Zoom = False
        End If

    End Sub

End Class
